searchable.recursivesearchtree

## Class BalancedAncestor

- java.lang.Object
- - searchable.recursivesearchtree.TreeNode
  - - searchable.recursivesearchtree.BalancedAncestor

- Direct Known Subclasses:
    AVLTreeNode, BalancedTreeNode

      class BalancedAncestor
      extends TreeNode

  Implementace kořene rekurzivního vyhledávacího podstromu, který se má vyvážit.

  Užití: Nepoužívejte mimo tuto kompilační jednotku! Zde slouží jako uzel uvnitř stromu.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BalancedAncestor(SearchableElement elem)` Vyrobí kořen podstromu, který se má vyvážit.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `TreeNode` | `balance(TreeNode parent, RecursiveSearchTree tree)` Vyvažuje podstrom, jehož je kořenem.
    `void` | `insert(TreeNode node, RecursiveSearchTree tree)` Vloží uzel do stromu, slouží k opětovnému vložení vyňatého uzlu při vyvažování.

    - ### Methods inherited from class searchable.recursivesearchtree.TreeNode

      `finalize, getContents, getCount, getLeft, getReadable, getRight, getWeight, remove, removeLeftmost, removeRightmost, select, setContents, setLeft, setRight, setWeight, setWeight, update`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BalancedAncestor

          public BalancedAncestor(SearchableElement elem)

      Vyrobí kořen podstromu, který se má vyvážit.
      Parameters:
        `elem` - ohodnocení nového uzlu

  - ### Method Detail

    - #### insert

          public void insert(TreeNode node,
                             RecursiveSearchTree tree)

      Vloží uzel do stromu, slouží k opětovnému vložení vyňatého uzlu při vyvažování.
      Parameters:
        `node` - uzel, který se má vložit
        `tree` - strom, kam se má vložit

    - #### balance

          public TreeNode balance(TreeNode parent,
                                  RecursiveSearchTree tree)

      Vyvažuje podstrom, jehož je kořenem.
      Parameters:
        `parent` - kořen podstromu, který se má vyvážit
        `tree` - strom
      Returns:
        výsledný kořen vyváženého podstromu